<?php

// define all the events in the app

use Auth\BackAuth;
use Auth\CustomerAuth;
use Auth\RoleAuth;
use Event\AuthEvent;
use Event\PanierEvent;
use Event\TemplateEvent;

$dispatcher = Application::getEventDispatcher();

// ecouteur pour enregistrer la politique du client loggé / non loggé
$dispatcher->addListener(
    AuthEvent::LOAD,
    function (AuthEvent $event) {
        $handler = new CustomerAuth();
        $handler->register($event);
    }
);

$dispatcher->addListener(
    AuthEvent::LOAD,
    function (AuthEvent $event) {
        $handler = new BackAuth();
        $handler->register($event);

    }
);

$dispatcher->addListener(
    AuthEvent::LOAD,
    function (AuthEvent $event) {
        $handler = new RoleAuth();
        $handler->register($event);
    }
);

// ecouteur ajout panier
$dispatcher->addListener(
    PanierEvent::CHANGE,
    function (PanierEvent $event) {
        $panierHandler = new PanierHandler();
        $panierHandler->save($event);
    }
);

// ecouteur pre render template
$dispatcher->addListener(
    TemplateEvent::PRE_RENDER,
    function (TemplateEvent $event) {
        $common = new Common();
        $common->boot($event);
    }
);

$dispatcher->addListener(
    Event\TemplateEvent::PRE_RENDER,
    function (TemplateEvent $event) {
        $dediDebugBar = Application::getDebugBar();
        if ($dediDebugBar !== null) {
            $dediDebugBar->registerDataCollector($event);
        }
    }
);

$dispatcher->addSubscriber(new \EventListener\ReferencementListener());
$dispatcher->addSubscriber(new \EventListener\TrackingListener());