<?php

use Phinx\Migration\AbstractMigration;
use Phinx\Db\Adapter\MysqlAdapter;

class AddReferencement extends AbstractMigration
{
    public function change()
    {
        $this
            ->table("referencement", ['id' => false, 'primary_key' => ["referencement_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('referencement_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('referencement_date_ajout', 'datetime', ['null' => false, 'default' => '0000-00-00 00:00:00', 'after' => 'referencement_id'])
            ->addColumn('referencement_date_modif', 'datetime', ['null' => false, 'default' => '0000-00-00 00:00:00', 'after' => 'referencement_date_ajout'])
            ->addColumn('boutique_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'referencement_date_modif', 'signed' => false])
            ->addForeignKey('boutique_id', 'boutique', 'boutique_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addIndex(['boutique_id'], ['name' => "boutique_id", 'unique' => false])
            ->create();

        $this
            ->table("referencement_nom", ['id' => false, 'primary_key' => ["referencement_nom_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('referencement_nom_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('referencement_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'referencement_nom_id', 'signed' => false])
            ->addColumn('langue_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'referencement_id', 'signed' => false])
            ->addColumn('referencement_nom_informatif', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'langue_id'])
            ->addColumn('referencement_titre_page', 'string', ['null' => false, 'limit' => 500, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'referencement_nom_informatif'])
            ->addColumn('referencement_baseline', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'referencement_titre_page'])
            ->addColumn('referencement_meta_title', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'referencement_baseline'])
            ->addColumn('referencement_meta_desc', 'string', ['null' => false, 'limit' => 500, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'referencement_meta_title'])
            ->addColumn('referencement_meta_kw', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'referencement_meta_desc'])
            ->addColumn('referencement_meta_other', 'string', ['null' => false, 'limit' => 500, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'referencement_meta_kw'])
            ->addColumn('referencement_url', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'referencement_meta_other'])
            ->addForeignKey('referencement_id', 'referencement', 'referencement_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('langue_id', 'langue', 'langue_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addIndex(['langue_id', 'referencement_id'], ['name' => "langue_id_2", 'unique' => true])
            ->addIndex(['referencement_id'], ['name' => "referencement_id", 'unique' => false])
            ->addIndex(['langue_id'], ['name' => "langue_id", 'unique' => false])
            ->addIndex(['referencement_url'], ['name' => "referencement_url", 'unique' => false])
            ->create();
    }
}
