<?php

namespace Auth;

use Event\AuthEvent;
use Symfony\Component\EventDispatcher\Event;
use Symfony\Component\HttpFoundation\RedirectResponse;

class BackAuth
{
    /**
     * Function for register callback when we need check role 'back'
     *
     * @param Event $event
     */
    public function register(AuthEvent $event)
    {
        $event->getAuth()->register(
            'back',
            function (Auth $auth) {
                return $this->handle($auth);
            }
        );
    }

    /**
     *
     * @param Auth   $auth
     * @param string $roleName
     *
     * @return bool|RedirectResponse
     */
    public function handle(Auth $auth)
    {
        $request = $auth->getRequest();
        $module_page = $request->get('module');
        $value = 1;

        if (!isset($_SESSION['droit'][$module_page]['groupe_droit_somme'])) {
            return new RedirectResponse('/back');
        }
        if ((int)($_SESSION['droit'][$module_page]['groupe_droit_somme']) & $value) {
            return true; //il a le droit de faire l'action $value
        } else {
            return new RedirectResponse('/back');
        }
    }

}