<?php

namespace Auth;

use Application;
use Event\AuthEvent;
use Symfony\Component\EventDispatcher\Event;
use Symfony\Component\HttpFoundation\RedirectResponse;

class CustomerAuth
{
    /**
     * Function for register callback when we need check role 'cutomer'
     *
     * @param Event $event
     */
    public function register(AuthEvent $event)
    {
        $event->getAuth()->register(
            'customer',
            function (Auth $auth) {
                return $this->handle($auth);
            }
        );
    }

    /**
     *
     * @param Auth   $auth
     * @param string $roleName
     *
     * @return bool|RedirectResponse
     */
    public function handle(Auth $auth)
    {
        $request = $auth->getRequest();
        $route = $request->get('_route');

        // TODO : mettre en place un middleware HTTP

        $queryString = [];
        $routesProcess = ['order', 'coordonnees'];
        if (in_array($route, $routesProcess)) {
            $queryString['origin'] = 'panier';
        }

        $clientId = $request->getSession()->get('client_id');
        if (empty($clientId)) {
            return new RedirectResponse(
                Application::getRouter()->getRouter()->generate('login', $queryString)
            );
        }

        return true;
    }

}