<?php

/**
 * Class Cms
 */
class Cms
{

    const POSITION_FOOTER = 1;
    const POSITION_CREDITS = 4;

    const M_TOP_RIGHT = 11;
    const M_REASSURANCE = 9;
    const M_BLOC_FOOTER = 12;
    const M_CREDITS = 13;

    const PAGE_LIVR = 5;
    const PAGE_PAY = 4;
    const PAGE_SOR = 6;
    const PAGE_QSN = 6;
    const PAGE_CONTACT = 7;

    const TYPE_STANDARD = 'page';
    const TYPE_BLOCK    = 'block';
    const TYPE_ALIAS    = 'alias';


    protected $sql = null;

    /**
     * constructor
     */
    public function __construct()
    {

        $this->sql = SiteSQL::getInstance();
    }

    /**
     * @param array $formvars
     * @param string $champs
     * @return null
     */
    public function get($formvars = array(), $champs = "")
    {

        $lgId = Boutique::getInstance()->getLangue()->id;

        $sql = "SELECT *, page_nom_contenu";
        $sql.=" FROM (cms_menu m)";
        $sql.=" LEFT JOIN cms_menu_nom mn on (m.cms_menu_id = mn.cms_menu_id AND mn.langue_id = '" . $lgId . "')";
        $sql.=" LEFT JOIN cms_page p on (p.cms_menu_id = m.cms_menu_id)";
        $sql.=" LEFT JOIN cms_page_nom pn on (pn.cms_page_id = p.cms_page_id AND pn.langue_id = '" . $lgId . "')";
        if (empty($formvars['no_boutique'])) {
            $sql.=" INNER JOIN cms_menu_boutique cmb ON (m.cms_menu_id = cmb.cms_menu_id AND cmb.boutique_id = '".Boutique::getInstance()->id."')";
            $sql.=" INNER JOIN cms_page_boutique cpb ON (p.cms_page_id = cpb.cms_page_id AND cpb.boutique_id = '".Boutique::getInstance()->id."')";
        }
        $sql.=" WHERE 1";
        $sql.=" AND  m.menu_statut_id = 1";
        $sql.=" AND p.page_statut_id = 1";

        if (empty($formvars['no_boutique'])) {
            $sql.= " AND cmb.cms_menu_boutique_statut_id = '1'";
            $sql.= " AND cpb.cms_page_boutique_statut_id = '1'";
        }

        if (!empty($formvars['cms_menu_id']))
            $sql.=" AND m.cms_menu_id = '" . $formvars['cms_menu_id'] . "'";
        if (!empty($formvars['cms_page_id']))
            $sql.=" AND p.cms_page_id = '" . $formvars['cms_page_id'] . "'";

        if (!empty($formvars['menu_position_id']))
            $sql.=" AND m.menu_position_id = '" . $formvars['menu_position_id'] . "'";
        if (!empty($formvars['menu_nom_url']))
            $sql.=" AND mn.menu_nom_url = '" . $formvars['menu_nom_url'] . "'";
        if (!empty($formvars['page_nom_url']))
            $sql.=" AND pn.page_nom_url = '" . $formvars['page_nom_url'] . "'";

        $sql.=" ORDER BY page_rang";

        if (empty($champs)) {
            $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
            $data = $this->sql->record;
            foreach ($data as $k => $da) {
                if ($da['cms_page_type'] == self::TYPE_ALIAS) {
                    $pageAlias = $this->get(array('cms_page_id' => $da['alias_id']));
                    $pageAlias[0]['page_nom_nom'] = $da['page_nom_nom'];
                    $data[$k] = $pageAlias[0];
                }
            }

            return $data;
        } else {
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);
            return $this->sql->record[$champs];
        }
    }

    function getPosition($formvars = array(), $champs = "") {

        $sql = "SELECT *";
        $sql.=" FROM (cms_menu m)";
        $sql.=" INNER JOIN cms_menu_nom mn ON (m.cms_menu_id = mn.cms_menu_id AND mn.langue_id = '" . Boutique::getInstance()->getLangue()->id . "')";
        if(empty($formvars['no_boutique'])) {
            $sql.=" INNER JOIN cms_menu_boutique cmb ON (m.cms_menu_id = cmb.cms_menu_id AND cmb.boutique_id = '".Boutique::getInstance()->id."')";
        }
        $sql.=" WHERE 1";
        $sql.=" AND m.menu_statut_id = 1";

        if(empty($formvars['no_boutique'])) {
            $sql.= " AND cmb.cms_menu_boutique_statut_id = '1'";
        }

        if (!empty($formvars['cms_menu_id']))
            $sql.=" AND m.cms_menu_id = '" . $formvars['cms_menu_id'] . "'";
        if (!empty($formvars['menu_position_id']))
            $sql.=" AND m.menu_position_id = '" . $formvars['menu_position_id'] . "'";
        if (!empty($formvars['menu_nom_url']))
            $sql.=" AND mn.menu_nom_url = '" . $formvars['menu_nom_url'] . "'";

        $sql.=" ORDER BY menu_rang";

        if (empty($champs)) {
            $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
            return $this->sql->record;
        } else {
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);
            return $this->sql->record[$champs];
        }
    }

    function getMenu($formvars = array(), $champs = "") {

        $sql = " SELECT *";
        $sql.=" FROM (cms_page p)";
        $sql.=" LEFT JOIN cms_page_nom pn ON (p.cms_page_id = pn.cms_page_id AND pn.langue_id = '" . Boutique::getInstance()->getLangue()->id . "')";
        if(empty($formvars['no_boutique'])) {
            $sql.=" INNER JOIN cms_page_boutique cpb ON (p.cms_page_id = cpb.cms_page_id AND cpb.boutique_id = '".Boutique::getInstance()->id."')";
        }
        $sql.=" WHERE 1";

        $sql.=" AND p.page_statut_id = 1";

        if(empty($formvars['no_boutique'])) {
            $sql.= " AND cpb.cms_page_boutique_statut_id = '1'";
        }

        if (!empty($formvars['menu_position_id']))
            $sql.=" AND p.cms_menu_id = '" . $formvars['menu_position_id'] . "'";

        if (!empty($formvars['page_nom_url']))
            $sql.=" AND pn.page_nom_url = '" . $formvars['page_nom_url'] . "'";
        if (!empty($formvars['parent_id']))
            $sql.=" AND (p.parent_id = '" . $formvars['parent_id'] . "' AND p.cms_menu_id IS NULL)";

        $sql .= " ORDER BY p.page_rang";

        if (empty($champs)) {
            $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
            $data = $this->sql->record;
            foreach ($data as $k => $da) {
                if ($da['cms_page_type'] == 'alias') {
                    $pageAlias = $this->get(array('cms_page_id' => $da['alias_id']));
                    $pageAlias[0]['page_nom_nom'] = $da['page_nom_nom'];
                    $data[$k] = $pageAlias[0];
                }
            }

            return $data;
        } else {
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);
            return $this->sql->record[$champs];
        }
    }

    function isChild($id) {
        $formvars['parent_id'] = $id;
        $childExist = $this->getMenu($formvars);

        if (!empty($childExist)) {
            // parent existe
            return true;
        } else {
            // Parent existe pas
            return false;
        }
    }

    function getPageAssoc($formvars = array(), $champs = "") {
        $sql = " SELECT *";
        $sql.=" FROM (cms_page p)";
        $sql.=" LEFT JOIN cms_page_nom pn ON(p.cms_page_id = pn.cms_page_id AND pn.langue_id = '".Boutique::getInstance()->getLangue()->id."')";
        if(empty($formvars['no_boutique'])) {
            $sql.=" INNER JOIN cms_page_boutique cpb ON (p.cms_page_id = cpb.cms_page_id AND cpb.boutique_id = '".Boutique::getInstance()->id."')";
        }
        $sql.=" WHERE 1";
        $sql.=" AND p.page_statut_id = 1";
        if (!empty($formvars['page_nom_url']))
            $sql.=" AND pn.page_nom_url = '" . $formvars['page_nom_url'] . "'";
        if (!empty($formvars['parent_id']))
            $sql.=" AND (p.parent_id = '" . $formvars['parent_id'] . "' OR p.cms_menu_id IS NULL)";
        if (!empty($formvars['cms_menu_id']))
            $sql.=" AND p.cms_menu_id = '" . $formvars['cms_menu_id'] . "'";


        if (empty($champs)) {
            $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
            $data = $this->sql->record;
            foreach ($data as $k => $da) {
                if ($da['cms_page_type'] == 'alias') {
                    $pageAlias = $this->get(array('cms_page_id' => $da['alias_id']));
                    $pageAlias[0]['page_nom_nom'] = $da['page_nom_nom'];
                    $data[$k] = $pageAlias[0];
                }
            }

            return $data;
        } else {
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);
            return $this->sql->record[$champs];
        }
    }

    // permet de recuperer la liste des sujets
    function getSujet($formvars = array(), $champs = "") {

        $sql = " SELECT s.sujet_id, s.sujet_rang, sn.sujet_nom_nom, sn.sujet_nom_email";
        $sql.= " FROM (sujet s)";
        $sql.= " INNER JOIN sujet_nom sn ON(s.sujet_id = sn.sujet_id AND sn.langue_id = '".Boutique::getInstance()->getLangue()->id."')";
        if(empty($formvars['no_boutique'])) {
            $sql.=" INNER JOIN sujet_boutique sb ON (s.sujet_id = sb.sujet_id AND sb.boutique_id = '".Boutique::getInstance()->id."')";
        }
        $sql.= " WHERE 1";

        if(empty($formvars['no_boutique'])) {
            $sql.= " AND sb.sujet_boutique_statut_id = '1'";
        }

        if(!empty($formvars['sujet_id'])) {
            $sql.= " AND s.sujet_id = '".$formvars['sujet_id']."'";
        }

        $sql.= " GROUP BY s.sujet_id ORDER BY s.sujet_rang";

        if (empty($champs)) {
            $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
            return $this->sql->record;
        } else {
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);
            return $this->sql->record[$champs];
        }
    }

    public function getAutoComplete($formvars = array())
    {

        if (empty($formvars['id']) && mb_strlen($formvars['search']) < 2) {
            return array();
        }

        $sql = "SELECT cpn.cms_page_id, cpn.page_nom_nom";
        $sql .= " FROM cms_page_nom cpn";
        $sql .= " WHERE 1";

        if (!empty($formvars['id'])) {
            $sql .= " AND cpn.cms_page_id = '" . $formvars['id'] . "'";
        }

        if (!empty($formvars['search'])) {
            $sql .= " AND (cpn.page_nom_nom LIKE '%" . $formvars['search'] . "%'";
            $sql .= " OR cpn.cms_page_id LIKE '%" . $formvars['search'] . "%'
            )";
        }
        $sql .= " GROUP BY cpn.cms_page_nom_id";
        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);

        return $this->sql->record;
    }
}
