<?php

/**
 * Class Temoignage
 */
class Temoignage extends Model {

    protected $table = 'temoignage';

    public function __construct($id = null)
    {
        $this->leftJoin[] = array('temoignage_etoile', 'te.temoignage_etoile_id', 't.temoignage_etoile_id');
        $this->leftJoin[] = array(
            'temoignage_etoile_nom',
            'AND',
            array('ten.temoignage_etoile_id', 'te.temoignage_etoile_id'),
            array('ten.langue_id', Boutique::getInstance()->getLangue()->id),
        );

        parent::__construct($id);
    }

    // recuperation des temoignage
    /*function get($formvars = array(), $champs = '') {

        $lgId = Boutique::getInstance()->getLangue()->id;

        //selection des champs
        $sql = "SELECT t.temoignage_id, t.temoignage_date_ajout, t.temoignage_titre, t.temoignage_pseudo, t.temoignage_texte";
        $sql .=", te.temoignage_etoile_valeur, te.temoignage_etoile_image, ten.temoignage_etoile_nom_nom";

        //selection des tables
        $sql .= " FROM temoignage t";
        $sql .= " LEFT JOIN temoignage_etoile te ON (t.temoignage_etoile_id = te.temoignage_etoile_id)";
        $sql .= " LEFT JOIN temoignage_etoile_nom ten ON (t.temoignage_etoile_id = ten.temoignage_etoile_id AND ten.langue_id = '" . $lgId . "')";

        //Condition
        $sql.=" WHERE t.temoignage_statut_id = 1";
        $sql.=" AND t.langue_id = '" . $lgId . "'";

        if (!empty($formvars['produit_id'])) {
            $sql .= " AND t.produit_id = '" . $formvars['produit_id'] . "'";
        }
        if (!empty($formvars['produit_attribut_id'])) {
            $sql .= " AND t.produit_attribut_id = '" . $formvars['produit_attribut_id'] . "'";
        }
        if (!empty($formvars['client_id'])) {
            $sql .= " AND t.client_id = '" . $formvars['client_id'] . "'";
        }
        if (!empty($formvars['temoignage_id'])) {
            $sql .= " AND t.temoignage_id = '" . $formvars['temoignage_id'] . "'";
        }

        // Order By
        if (!empty($formvars['order'])) {
            switch ($formvars['order']) {
                case "random":
                    $sql .= " ORDER BY RAND()";
                    break;
                default:
                    $sql .= " ORDER BY t.temoignage_date_ajout";
                    break;
            }
        }
        //-- Order By
        // Gestion de la limit
        if (!empty($formvars['limit']))
            $sql.=" LIMIT " . $formvars['limit'];

        if (empty($champs)) {
            return $this->sql->getAll($sql);
        } else {
            $result = $this->sql->getOne($sql);
            return $result[$champs];
        }
    }*/

    function getEtoile($formvars = array(), $champs = "") {
        $sql = "SELECT te.*, ten.*";
        $sql.=" FROM (temoignage_etoile te, temoignage_etoile_nom ten)";
        $sql.=" WHERE te.temoignage_etoile_id = ten.temoignage_etoile_id";
        $sql.=" AND langue_id = '" . Boutique::getInstance()->getLangue()->id . "'";
        if (!empty($formvars['temoignage_etoile_valeur']))
            $sql.=" AND temoignage_etoile_valeur = '" . $formvars['temoignage_etoile_valeur'] . "'";
        $sql.=" ORDER BY temoignage_etoile_valeur ASC";

        if (empty($champs)) {
            return $this->sql->getAll($sql);
        } else {
            $result = $this->sql->getOne($sql);
            return $result[$champs];
        }
    }

    function infos($formvars = array()) {
        $sql = "SELECT COUNT(temoignage_id) as nb_comm, ROUND(AVG(te.temoignage_etoile_valeur)) as note_avg";
        $sql.=" FROM (temoignage t)";
        $sql.=" LEFT JOIN temoignage_etoile te ON (t.temoignage_etoile_id = te.temoignage_etoile_id)";
        $sql.=" WHERE 1";
        $sql.=" AND t.langue_id = '" . Boutique::getInstance()->getLangue()->id . "'";
        $sql.=" AND temoignage_statut_id = 1";
        if (isset($formvars["produit_id"]))
            $sql.=" AND t.produit_id = '" . $formvars["produit_id"] . "'";
        if (isset($formvars["produit_attribut_id"]))
            $sql.=" AND t.produit_attribut_id = '" . $formvars["produit_attribut_id"] . "'";

        $sql.=" GROUP BY t.produit_id";

        return $this->sql->getOne($sql);

    }

    public function getQuery($formvars = array())
    {
        $q = parent::getQuery($formvars);
        $q->select("t.*");
        return $q;
    }

}