<?php

/**
 * Class Tracking
 */
class Tracking
{
    protected $tracker = [];
    protected $sql = null;

    public function __construct()
    {
        $this->sql = SiteSQL::getInstance();

        // array_push($this->tracker, 'GoogleAnalytics');
    }

    public static function initReferer()
    {

        // TAG REFERER
        if (!empty($_GET["utm_source"]) && empty($_GET["referer"])) {
            $_GET["referer"] = $_GET["utm_source"];
        }
        if (!empty($_GET["referer"])) {
            $cookieDate = time() + (3600 * 24 * 30); // valable 30 jours
            setcookie('referer', '', $cookieDate, '/');
            setcookie('referer', $_GET['referer'], $cookieDate, '/');
        }

        if (!isset($_SESSION['referer'])) {
            $_SESSION['referer'] = '';
        }

        if (!empty($_COOKIE['referer']) && $_SESSION['referer'] != $_COOKIE['referer']) {
            $_SESSION['referer'] = $_COOKIE['referer'];
        }

        // TAG REFERER
    }

    // on enregistre le cookie

    function get($action, $param = [], $smarty = "")
    {

        if (method_exists($this, $action)) {
            list($action, $param['extra']) = $this->$action($param);
        }

        $param['smarty'] = &$smarty;

        foreach ($this->tracker as $class) {
            if (method_exists($class, $action)) {
                call_user_func_array([$class, $action], [$param]);
            }
        }
    }

    function setReferer($type, $id, $delete = false)
    {

        if (!empty($_SESSION['referer'])) {
            $query = new Query();
            switch ($type) {
                case 'commande':
                    $query->update('commande')
                        ->value('commande_referer', $_SESSION['referer'])
                        ->where('commande_id', $id);
                    $this->sql->query($query->build());
                    break;
            }
        }

        if ($delete == true) {
            if (!empty($_SESSION['referer'])) {
                unset($_SESSION['referer']);
            }
            setcookie('referer', '', time() - 3600, '/');
        }
    }

    function paiementPassif($param = [])
    {

        $produit = new Produit();
        // recuperation des données
        $commande = new Commande;
        list($arrCommande) = $commande->get(['commande_id' => $param['commande_id']]);
        $arrCommande['products'] = $commande->getProduit(['commande_id' => $param['commande_id']]);

        // preparation des données
        $info['commande_id'] = 'C' . $arrCommande['commande_id'];
        $info['commande_stotal_ht'] = round($arrCommande['commande_stotal_ht'], 2);
        $info['commande_stotal_ttc'] = $arrCommande['commande_stotal_ttc'];
        $info['commande_stotal_taxe'] = round($arrCommande['commande_stotal_taxe'], 2);
        $info['commande_port_ht'] = round($arrCommande['commande_port_ht'], 2);
        $info['commande_port_ttc'] = $arrCommande['commande_port_ttc'];
        $info['commande_total_ht'] = round($arrCommande['commande_total_ht'], 2);
        $info['commande_total_ttc'] = $arrCommande['commande_total_ttc'];
        $info['commande_total_taxe'] = round($arrCommande['commande_total_taxe'], 2);
        $info['commande_referer'] = $arrCommande['commande_referer'];
        $info['livraison_ville'] = $arrCommande['livraison_ville'];
        $info['livraison_cp'] = $arrCommande['livraison_cp'];
        $info['livraison_pays'] = $arrCommande['livraison_pays'];
        $info['livraison_pays_code'] = $arrCommande['livraison_pays_code'];

        $info['produits'] = [];
        foreach ($arrCommande['products'] as $product) {
            array_push(
                $info['produits'],
                [
                    'produit_ref' => $product['produit_ref'],
                    'produit_nom' => $product['produit_nom'],
                    'prix_ttc' => $product['prix_ttc'],
                    'qte' => $product['qte'],
                    'categories' => $produit->getCategorie(['produit_id' => $product['produit_id']]),
                ]
            );
        }

        // envoi des données
        return ['paiement', $info];
    }

    function paiementActif($param = [])
    {

        $produit = new Produit();
        // recuperation des donnes
        $panier = Panier::getInstance();
        $arrProduit = $panier->getProducts();

        list($sTotalHT, $sTotalTTC) = $panier->getTotalProducts();
        list($aPayerHT, $aPayerTTC) = $panier->getAPayer();
        $shipping = $panier->getShipping();

        $addrShipping = $panier->getAddressShipping();

        // preparation des données
        $info['commande_id'] = 'T' . $panier->getReference();
        $info['commande_stotal_ht'] = $sTotalHT;
        $info['commande_stotal_ttc'] = $sTotalTTC;
        $info['commande_stotal_taxe'] = $info['commande_stotal_ttc'] - $info['commande_stotal_ht'];
        $info['commande_port_ht'] = $shipping->port_ht;
        $info['commande_port_ttc'] = $shipping->port_ttc;
        $info['commande_total_ht'] = $aPayerHT;
        $info['commande_total_ttc'] = $aPayerTTC;
        $info['commande_total_taxe'] = $info['commande_total_ttc'] - $info['commande_total_ht'];
        $info['commande_referer'] = ''; // PENDING : lorsque l'application referer
        $info['livraison_ville'] = $addrShipping->adresse_ville;
        $info['livraison_cp'] = $addrShipping->adresse_cp;
        $info['livraison_pays'] = $addrShipping->pays_nom_nom;
        $info['livraison_pays_code'] = $addrShipping->pays_iso_code_2;

        $info['produits'] = [];
        foreach ($arrProduit as $product) {
            array_push(
                $info['produits'],
                [
                    'produit_ref' => $product['produit_ref'],
                    'produit_nom' => $product['produit_nom'],
                    'prix_ttc' => $product['produit_prix_ttc'],
                    'qte' => $product['quantite_order'],
                    'categories' => $produit->getCategorie(['produit_id' => $product['produit_id']]),
                ]
            );
        }

        // envoi des données
        return ['paiement', $info];
    }

    function recapitulatif($param = [])
    {

        $produit = new Produit();
        // recuperation des donnes
        $panier = Panier::getInstance();
        $arrProduit = $panier->getProducts();

        list($sTotalHT, $sTotalTTC) = $panier->getTotalProducts();
        list($aPayerHT, $aPayerTTC) = $panier->getAPayer();
        $shipping = $panier->getShipping();

        $addrShipping = $panier->getAddressShipping();

        // preparation des données
        $info['commande_stotal_ht'] = $sTotalHT;
        $info['commande_stotal_ttc'] = $sTotalTTC;
        $info['commande_stotal_taxe'] = $info['commande_stotal_ttc'] - $info['commande_stotal_ht'];
        $info['commande_port_ht'] = $shipping->port_ht;
        $info['commande_port_ttc'] = $shipping->port_ttc;
        $info['commande_total_ht'] = $aPayerHT;
        $info['commande_total_ttc'] = $aPayerTTC;
        $info['commande_total_taxe'] = $info['commande_total_ttc'] - $info['commande_total_ht'];
        $info['commande_referer'] = ''; // PENDING : lorsque l'application referer
        $info['livraison_ville'] = $addrShipping->adresse_ville;
        $info['livraison_cp'] = $addrShipping->adresse_cp;
        $info['livraison_pays'] = $addrShipping->pays_nom_nom;
        $info['livraison_pays_code'] = $addrShipping->pays_iso_code_2;

        $info['produits'] = [];
        foreach ($arrProduit as $product) {
            array_push(
                $info['produits'],
                [
                    'produit_ref' => $product['produit_ref'],
                    'produit_nom' => $product['produit_nom'],
                    'prix_ttc' => $product['produit_prix_ttc'],
                    'qte' => $product['quantite_order'],
                    'categories' => $produit->getCategorie(['produit_id' => $product['produit_id']]),
                ]
            );
        }

        // envoi des données
        return ['recapitulatif', $info];
    }

}