var gulp = require('gulp');
var gutil = require('gulp-util');
var concat = require('gulp-concat');
var sass = require('gulp-sass');
var minifyCss = require('gulp-minify-css');
var rename = require('gulp-rename');
var path = require('path');
var livereload = require('gulp-livereload');
var webserver = require('gulp-webserver');
var sourcemaps = require('gulp-sourcemaps');
var gulpCopy = require('gulp-copy');

var buildDir = '../../web/united_equipement/';

var paths = {
    sass: ['templates/assets/sass/**/*.scss'],
    js: ['templates/assets/js/**/*.js'],
	templates: ['./templates/**/*.tpl'],
    buildDir: buildDir,
    jsConcatSources: [
        './templates/assets/vendor/jquery/dist/jquery.min.js',
        './templates/assets/vendor/bootstrap-sass-official/assets/javascripts/bootstrap.min.js',
        './templates/assets/vendor/slick-carousel/slick/slick.min.js',
        './templates/assets/vendor/multilevelpushmenu/jquery.multilevelpushmenu.min.js',
        './templates/assets/vendor/bootstrap-touchspin/dist/jquery.bootstrap-touchspin.min.js',
        './templates/assets/vendor/jquery-nstSlider/dist/jquery.nstSlider.min.js',
        './templates/assets/vendor/bootstrap-tabcollapse/bootstrap-tabcollapse.js',
        //'./templates/assets/vendor/jQuery.mmenu/dist/core/js/jquery.mmenu.all.js',
        './templates/assets/vendor/jQuery.mmenu/src/core/js/jquery.mmenu.oncanvas.js',
        './templates/assets/vendor/jQuery.mmenu/src/addons/js/jquery.mmenu.offcanvas.js',
        './templates/assets/js/panier.js',
		'./templates/assets/js/address.js',
		'./templates/assets/js/common.js',
		'./templates/assets/js/functions.js'
    ],
    copyFiles: [
        {
            src: [
                './templates/assets/vendor/font-awesome/fonts/*',
                './templates/assets/vendor/slick-carousel/slick/fonts/*'
            ],
            dst: buildDir + 'fonts/',
            level: 6
        }
    ]
};

gulp.task('default', ['sass', 'scripts', 'watch']);

var sassIncludePaths = [
    './templates/assets/vendor/bootstrap-sass-official/assets/stylesheets/',
    './templates/assets/vendor/font-awesome/scss/',
    './templates/assets/vendor/susy/sass/',
    './templates/assets/vendor/breakpoint-sass/stylesheets/',
    './templates/assets/vendor/slick-carousel/slick/',
    './templates/assets/vendor/multilevelpushmenu/',
    './templates/assets/vendor/jquery-nstSlider/dist',
    './templates/assets/vendor/bootstrap-touchspin/src',
    './templates/assets/vendor/jQuery.mmenu/src/core/css'
    //'./templates/assets/vendor/sassy-maps/stylesheets/'
];

gulp.task('sass', function(done) {
    var sass_pipe = sass({
        includePaths: sassIncludePaths
    });
    sass_pipe.on('error', function(e) {
        gutil.log(e);
        this.emit('end');
    });

    gulp.src(['./templates/assets/sass/united.scss'])
        //.pipe(sourcemaps.init())
        .pipe(sass_pipe)
        //.pipe(sourcemaps.write())
        .pipe(gulp.dest(paths.buildDir + 'css/'))
        .pipe(minifyCss({
            keepSpecialComments: 0
        }))
        .pipe(rename({ extname: '.min.css' }))
        .pipe(gulp.dest(paths.buildDir + 'css/'))
        .pipe(livereload())
        .on('end', done);
});

gulp.task('sass-dev', function(done) {
    var sass_pipe = sass({
        includePaths: sassIncludePaths
    });
    sass_pipe.on('error', function(e) {
        gutil.log(e);
        this.emit('end');
    });

    gulp.src(['./templates/assets/sass/united.scss'])
        .pipe(sourcemaps.init())
        .pipe(sass_pipe)
        .pipe(sourcemaps.write())
        .pipe(gulp.dest(paths.buildDir + 'css/'))
        .pipe(livereload())
        .on('end', done);
});

gulp.task('watch', ['sass-dev'], function () {
    livereload.listen();
    gulp.watch(paths.sass, ['sass-dev'], function(f) {
        console.log(f);
    });
    gulp.watch(paths.js, ['scripts']);
});

gulp.task('scripts', function() {
    return gulp.src(paths.jsConcatSources)
        .pipe(concat('all.js'))
        .pipe(gulp.dest(paths.buildDir + 'js/'))
        .pipe(livereload())
    ;
});

gulp.task('copy', function() {

    for (var i = 0; i < paths.copyFiles.length; i++) {
        gulp.src(paths.copyFiles[i]['src'])
            .pipe(gulpCopy(paths.copyFiles[i]['dst'], {
                prefix: paths.copyFiles[i]['level']
            }));
    }

    //return
    //    gulp
    //    .src(paths.copyFiles)
    //    .pipe(gulpCopy('./templates/assets/js', {
    //        prefix: 2
    //    }));
});
